## dmrgpp 6.02

=== CMakeLists.txt ===
project (dmrgpp)
cmake_minimum_required(VERSION 3.4)

add_subdirectory(src)
add_subdirectory(doc)

=== doc/CMakeLists.txt ===
add_custom_command( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/manual.tex
  COMMAND bash -c "cp ${CMAKE_CURRENT_SOURCE_DIR}/*.pdf ${CMAKE_CURRENT_BINARY_DIR}/"
  COMMAND bash -c "cp ${CMAKE_CURRENT_SOURCE_DIR}/*.png ${CMAKE_CURRENT_BINARY_DIR}/"
  COMMAND find ${dmrgpp_SOURCE_DIR} -iname "*.h" -or -iname "*.cpp" | perl ${PsimagLite_SOURCE_DIR}/../scripts/doc.pl ${CMAKE_CURRENT_SOURCE_DIR}/manual.ptex ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} 
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating manual.tex from manual.ptex"
#  VERBATIM
  )

add_custom_target( manual.pdf ALL
  COMMAND pdflatex manual.tex
  COMMAND bibtex manual.aux
  COMMAND pdflatex manual.tex
  COMMAND pdflatex manual.tex
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Generating manual.pdf"
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/manual.tex
  VERBATIM
  )

=== doc/Makefile ===
CPPFLAGS = -I../src \
	   -I../src/Geometry
CXX = g++

all: manual.pdf tutorial.pdf

manual.tex: manual.ptex ../scripts/doc.pl
	find ../src -iname "*.h" -or -iname "*.cpp" |\
              perl ../scripts/doc.pl manual.ptex

tutorial.tex: tutorial.ptex ../src/*h ../drivers/*cpp ../scripts/doc.pl
	find ../src ../drivers -iname "*.h" -or -iname "*.cpp" |\
perl ../scripts/doc.pl tutorial.ptex

manual.pdf: manual.tex
	pdflatex manual.tex
#	bibtex manual.aux
	pdflatex manual.tex
	pdflatex manual.tex

tutorial.pdf: tutorial.tex
	pdflatex tutorial.tex
#	bibtex tutorial.tex
	pdflatex tutorial.tex
	pdflatex tutorial.tex

clean:
	rm -f ../README.tex
	rm -f manual.pdf manual.tex tutorial.pdf tutorial.tex

=== debian/changelog ===
dmrgpp (6.02-2) unstable; urgency=medium

  * Added autopkgtest

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 22 Dec 2021 14:21:41 +0100

dmrgpp (6.02-1) unstable; urgency=medium

  * New upstream version 6.02
  * d/watch: use component to deal with the embeded psimaglite library
  * d/rules: updated for psimaglite component
  * d/control: Added Debian PaN maintainers
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 20 Dec 2021 13:27:46 +0100

dmrgpp (6.00-2) unstable; urgency=medium

  * Source-only upload for unstable
  * Fix generated Makefile for DEB_HOST_MULTIARCH hdf5/serial path

 -- Neil Williams <codehelp@debian.org>  Wed, 08 Dec 2021 10:33:42 +0000

dmrgpp (6.00-1) unstable; urgency=medium

  * Initial release. (Closes: #994936: ITP: dmrgpp -- Density matrix
    renormalization group algorithm)
  * Fix omissions in d.copyright

 -- Neil Williams <codehelp@debian.org>  Mon, 06 Dec 2021 10:00:09 +0000

=== debian/control ===
Source: dmrgpp
Section: science
Priority: optional
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
 Neil Williams <codehelp@debian.org>,
 Picca Frédéric-Emmanuel <picca@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libboost1.74-dev,
 libhdf5-dev,
 libopenblas-dev,
Standards-Version: 4.6.0
Homepage: https://github.com/g1257/dmrgpp
Vcs-Browser: https://salsa.debian.org/science-team/dmrgpp
Vcs-Git: https://salsa.debian.org/science-team/dmrgpp.git
Rules-Requires-Root: no

Package: dmrgpp
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Density matrix renormalization group algorithm
 DMRGPP / DMRG++ is an implementation of the Density matrix
 renormalization group algorithm which attempts to find the
 lowest-energy matrix product state wavefunction corresponding to the
 total energy of the system. DMRGPP embeds the PsimagLite utility to
 obtain codes for the simulation of strongly correlated electrons.
 .
 This package contains the dmrg executable and helpers, built using
 OpenBLAS.

=== debian/rules ===
#!/usr/bin/make -f

# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_clean:
	[ -f psimaglite/lib/Makefile ] && $(MAKE) -C psimaglite/lib/ clean || true
	[ -f src/Makefile ] && $(MAKE) -C src clean || true
	$(RM) src/KronUtil/libkronutil.a src/libdmrgpp.a src/operator
	$(RM) psimaglite/lib/Makefile src/GitRevision.h
	$(RM) src/KronUtil/Makefile src/Makefile

override_dh_auto_configure:
	cd psimaglite/lib/ && ./configure.pl -c ../../debian/debianconfig.psiTag
	cd ./src && ./configure.pl -c ../debian/debianconfig.psiTag

override_dh_auto_build:
	sed -i 's#LDFLAGS += -L/usr/lib/x86_64-linux-gnu/hdf5/serial/#LDFLAGS += -L/usr/lib/${DEB_HOST_MULTIARCH}/hdf5/serial/#' ./src/Makefile
	$(MAKE) -C psimaglite/lib/
	$(MAKE) -C src

override_dh_auto_install:
	cp doc/dmrg.8 debian/dmrg.1
	dh_installman debian/dmrg.1
	install -d debian/dmrgpp/usr/bin
	install src/dmrg debian/dmrgpp/usr/bin
	install -d debian/dmrgpp/usr/lib/${DEB_HOST_MULTIARCH}/dmrgpp/bin/
	install src/observe debian/dmrgpp/usr/lib/${DEB_HOST_MULTIARCH}/dmrgpp/bin/
	install src/toolboxdmrg debian/dmrgpp/usr/lib/${DEB_HOST_MULTIARCH}/dmrgpp/bin/
	install src/operator debian/dmrgpp/usr/lib/${DEB_HOST_MULTIARCH}/dmrgpp/bin/
	install src/manyOmegas debian/dmrgpp/usr/lib/${DEB_HOST_MULTIARCH}/dmrgpp/bin/
	install src/procOmegas debian/dmrgpp/usr/lib/${DEB_HOST_MULTIARCH}/dmrgpp/bin/

=== debian/tests/control ===
Test-Command: set -efu
 ; cp -rf scripts TestSuite "$AUTOPKGTEST_TMP"
 ; cd "$AUTOPKGTEST_TMP"
 ; mkdir -p src
 ; cp -f /usr/bin/dmrg `find /usr/lib -name observe -type f` src
 ; git clone https://code.ornl.gov/gonzalo_3/OraclesDmrg.git
 ; cd "$AUTOPKGTEST_TMP"/OraclesDmrg
 ; git pull origin features
 ; cd "$AUTOPKGTEST_TMP"/TestSuite
 ; rm -Rf tests/
 ; cp -f batchDollarized.pbs.sample batchDollarized.pbs
 ; ./ci.pl -n "0-*" -S bash
 ; ./postCi.pl -g "$AUTOPKGTEST_TMP"/OraclesDmrg/oracles/tests -n '0-*'
Depends: dmrgpp, git, libmath-round-perl
Restrictions: allow-stderr, needs-internet

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# This watch file only monitors DMRGPP
# Separate checks need to be done for PsimagLite
# https://github.com/g1257/PsimagLite

# GitHub PsimagLite in PsimagLite directory
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%PsimagLite-$1.tar.gz%,component=psimaglite" \
  https://github.com/g1257/PsimagLite/tags \
  (?:.*?/)?v?(\d[\d.]*)\.tar\.gz ignore

# GitHub DMRGPP
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%dmrgpp-$1.tar.gz%" \
   https://github.com/g1257/dmrgpp/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz group

## dmrgpp 6.04

=== debian/changelog ===
dmrgpp (6.04-4) unstable; urgency=medium

  * d/t/control: still timeout. Reduce the number of test executed for now

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 03 Aug 2023 08:35:56 +0200

dmrgpp (6.04-3) unstable; urgency=medium

  * d/t/control: Fix the autopkgtest

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 02 Aug 2023 08:19:24 +0200

dmrgpp (6.04-2) unstable; urgency=medium

  * d/t/control: split the tests into three batch to avoid timeout.
  * Bug fix: "flaky autopkgtest on amd64: times out", thanks to Paul
    Gevers (Closes: #1026864).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 01 Aug 2023 15:10:11 +0200

dmrgpp (6.04-1) unstable; urgency=medium

  [ Neil Williams ]
  * Update control to remove myself from Uploaders

  [ Picca Frédéric-Emmanuel ]
  * New upstream version 6.04
  * d/p/0003-master-error-fixed-after-release.patch
  * Bug fix: "Please package the new 6.04 version", thanks to Picca
    Frédéric-Emmanuel (Closes: #1042740).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 31 Jul 2023 15:15:49 +0200

dmrgpp (6.02-3) unstable; urgency=medium

  * Exclude armhf from autopkgtest (Closes: #1003061)

 -- Neil Williams <codehelp@debian.org>  Tue, 08 Mar 2022 10:00:22 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
 Uploaders:
  Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>,
- Neil Williams <codehelp@debian.org>,
  Picca Frédéric-Emmanuel <picca@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,13 @@
 #!/usr/bin/make -f
+
+# TODO
+# (2023-07-28)
+# - embed via component the oracles files
+#   git clone https://code.ornl.gov/gonzalo_3/OraclesDmrg.git
+#   this way no need for an internet connection during autopkgtests
+# - I already ping the author for a (> 6.04) version which build out of the box.
+#   until then no need to package 6.04
+
 
 # output every command that modifies files on the build system.
 #export DH_VERBOSE = 1

=== debian/tests/control ===
Test-Command: debian/tests/run-test 0 150
Depends: dmrgpp, git, libmath-round-perl
Architecture: amd64, arm64, i386, ppc64el
Restrictions: allow-stderr, needs-internet

Test-Command: debian/tests/run-test 150 2029
Depends: dmrgpp, git, libmath-round-perl
Architecture: amd64, arm64, i386, ppc64el
Restrictions: allow-stderr, needs-internet

Test-Command: debian/tests/run-test 2029 3000
Depends: dmrgpp, git, libmath-round-perl
Architecture: amd64, arm64, i386, ppc64el
Restrictions: allow-stderr, needs-internet

## dmrgpp 6.06

=== doc/Makefile ===
CPPFLAGS = -I../src/Engine -I../src/Models/Heisenberg -I../src/Models/Heisenberg -I../src/Models/HubbardOneBand -I../src/Models/FeAsModel \
	   -IModels/Immm -I../src/Models/FeAsBasedScExtended -IModels/ExtendedHubbard1Orb -I../../PsimagLite/src -I../../PsimagLite/src/Geometry 
CXX = g++ 

all: manual.pdf

FILES = $(shell find ../src -iname "*.h" -or -iname "*.cpp")
manual.tex: manual.ptex ../README.md  $(FILES)
	find ../src -iname "*.h" -or -iname "*.cpp" |\
              perl ../../PsimagLite/scripts/doc.pl manual.ptex

manual.pdf: manual.tex ../README.md ../src/*h ../src/Engine/*h ../src/*cpp
	pdflatex manual.tex
	bibtex manual.aux
	pdflatex manual.tex
	pdflatex manual.tex

clean:
	rm -f ../README.tex
	rm -f manual.tex manual.pdf

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(PsimagLite)

add_library(PsimagLite STATIC MersenneTwister.cpp Matrix.cpp Mpi.cpp ApplicationInfo.cpp Concurrency.cpp ProgressIndicator.cpp MemResolv.cpp PsimagLite.cpp PsiBase64.cpp SpecialFunctions.cpp)

target_link_libraries( PsimagLite ${CMAKE_THREAD_LIBS_INIT} )

=== debian/changelog ===
dmrgpp (6.06-2build1) plucky; urgency=medium

  * No-change rebuild against libhdf5-310

 -- Miriam España Acebal <miriam.espana@canonical.com>  Sun, 26 Jan 2025 10:52:39 +0000

dmrgpp (6.06-2) unstable; urgency=medium

  * Bug fix: "switch to boost 1.83", thanks to Sebastian Ramacher (Closes:
    #1065303).
  * d/control: B-D on the generic libboost-dev instead of the versionned version.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 06 Mar 2024 11:07:49 +0100

dmrgpp (6.06-1) unstable; urgency=medium

  * d/t/control: reduce the number of thread  via OpenMP
    restore the full test suite.
  * New upstream version 6.06
  * Bug fix: "Fails to build source after successful build", thanks to
    Lucas Nussbaum (Closes: #1044429).
  * d/watch: Added the oraclesdmrg component
  * d/t/control: Added the riscv64 architecture to test via autopkgtests
  * d/t/run-tests: rework to make it work with the embeded oraclesdmrg

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Tue, 29 Aug 2023 16:35:38 +0200

=== debian/rules ===
--- 
+++ 
@@ -25,6 +25,7 @@
 	$(RM) src/KronUtil/libkronutil.a src/libdmrgpp.a src/operator
 	$(RM) psimaglite/lib/Makefile src/GitRevision.h
 	$(RM) src/KronUtil/Makefile src/Makefile
+	$(RM) -f src/KronUtil/test1 src/KronUtil/test2
 
 override_dh_auto_configure:
 	cd psimaglite/lib/ && ./configure.pl -c ../../debian/debianconfig.psiTag

=== debian/tests/control ===
Test-Command: debian/tests/run-test 0 150
Depends: dmrgpp, git, libmath-round-perl
Architecture: amd64, arm64, i386, ppc64el, riscv64
Restrictions: allow-stderr

Test-Command: debian/tests/run-test 150 2029
Depends: dmrgpp, git, libmath-round-perl
Architecture: amd64, arm64, i386, ppc64el, riscv64
Restrictions: allow-stderr

Test-Command: debian/tests/run-test 2029 *
Depends: dmrgpp, git, libmath-round-perl
Architecture: amd64, arm64, i386, ppc64el, riscv64
Restrictions: allow-stderr
